/*
*******************************************************************************
**
**  This device driver was created by Applilet2 for 78K0/Kx2
**  8-Bit Single-Chip Microcontrollers
**
**  Copyright(C) NEC Electronics Corporation 2002 - 2011
**  All rights reserved by NEC Electronics Corporation.
**
**  This program should be used on your own responsibility.
**  NEC Electronics Corporation assumes no responsibility for any losses
**  incurred by customers or third parties arising from the use of this file.
**
**  Filename :	Port.c
**  Abstract :	This file implements device driver for PORT module.
**  APIlib :	Applilet2 for 78K0/Kx2 V2.41 [29 Apr. 2008]
**
**  Device :	uPD78F0512_48
**
**  Compiler :	CC78K0
**
**  Creation date:	2011/07/14
**  
*******************************************************************************
*/

/*
*******************************************************************************
**  Include files
*******************************************************************************
*/
#include "macrodriver.h"
#include "Port.h"
/* Start user code for include definition. Do not edit comment generated here */
/* End user code for include definition. Do not edit comment generated here */
#include "user_define.h"

/*
*******************************************************************************
**  Global define
*******************************************************************************
*/
/* Start user code for global definition. Do not edit comment generated here */
/* End user code for global definition. Do not edit comment generated here */



/*
**-----------------------------------------------------------------------------
**
**	Abstract:
**		This function initializes setting for Port I/O.
**
**	Parameters:
**		None
**
**	Returns:
**		None
**
**-----------------------------------------------------------------------------
*/
void PORT_Init( void )
{
	P0 = Pn0_OUTPUT_0 | Pn1_OUTPUT_0;
	P2 = Pn0_OUTPUT_0 | Pn1_OUTPUT_0 | Pn2_OUTPUT_0 | Pn3_OUTPUT_0 | Pn4_OUTPUT_0 | Pn5_OUTPUT_0;
	P3 = Pn1_OUTPUT_0 | Pn2_OUTPUT_0 | Pn3_OUTPUT_0;
	P4 = Pn0_OUTPUT_0 | Pn1_OUTPUT_0;
	P6 = Pn0_OUTPUT_0 | Pn1_OUTPUT_0 | Pn2_OUTPUT_0 | Pn3_OUTPUT_0;
	P7 = Pn0_OUTPUT_0 | Pn1_OUTPUT_0 | Pn2_OUTPUT_0 | Pn3_OUTPUT_0 | Pn4_OUTPUT_0 | Pn5_OUTPUT_0;
	P12 = Pn0_OUTPUT_0 | Pn1_OUTPUT_0 | Pn2_OUTPUT_0 | Pn3_OUTPUT_0 | Pn4_OUTPUT_0;
	P13 = Pn0_OUTPUT_0;
	P14 = Pn0_OUTPUT_0;

	PU1 = PUn0_PULLUP_ON | PUn1_PULLUP_ON | PUn2_PULLUP_ON | PUn3_PULLUP_ON | PUn4_PULLUP_ON | PUn5_PULLUP_ON | PUn6_PULLUP_ON | PUn7_PULLUP_ON;
	PU3 = PUn0_PULLUP_ON;
	PM0 = PMn0_MODE_OUTPUT | PMn1_MODE_OUTPUT | PM0_DEFAULT;
	PM1 = PMn0_MODE_INPUT | PMn1_MODE_INPUT | PMn2_MODE_INPUT | PMn3_MODE_INPUT | PMn4_MODE_INPUT | PMn5_MODE_INPUT | PMn6_MODE_INPUT | PMn7_MODE_INPUT;
	PM2 = PMn0_MODE_OUTPUT | PMn1_MODE_OUTPUT | PMn2_MODE_OUTPUT | PMn3_MODE_OUTPUT | PMn4_MODE_OUTPUT | PMn5_MODE_OUTPUT | PMn6_NOT_USE | PMn7_NOT_USE;
	PM3 = PMn0_NOT_USE | PMn1_MODE_OUTPUT | PMn2_MODE_OUTPUT | PMn3_MODE_OUTPUT | PM3_DEFAULT;
	PM4 = PMn0_MODE_OUTPUT | PMn1_MODE_OUTPUT | PM4_DEFAULT;
	PM6 = PMn0_MODE_OUTPUT | PMn1_MODE_OUTPUT | PMn2_MODE_OUTPUT | PMn3_MODE_OUTPUT | PM6_DEFAULT;
	PM7 = PMn0_MODE_OUTPUT | PMn1_MODE_OUTPUT | PMn2_MODE_OUTPUT | PMn3_MODE_OUTPUT | PMn4_MODE_OUTPUT | PMn5_MODE_OUTPUT | PM7_DEFAULT;
	PM12 = PMn0_MODE_OUTPUT | PMn1_MODE_OUTPUT | PMn2_MODE_OUTPUT | PMn3_MODE_OUTPUT | PMn4_MODE_OUTPUT | PM12_DEFAULT;
	PM14 = PMn0_MODE_OUTPUT | PM14_DEFAULT;
	ADPC = PORT_ADPC_6DIO;
}

/* Start adding user code. Do not edit comment generated here */
/* End user code adding. Do not edit comment generated here */


