/*
*******************************************************************************
**
**  This device driver was created by Applilet2 for 78K0/Kx2
**  8-Bit Single-Chip Microcontrollers
**
**  Copyright(C) NEC Electronics Corporation 2002 - 2011
**  All rights reserved by NEC Electronics Corporation.
**
**  This program should be used on your own responsibility.
**  NEC Electronics Corporation assumes no responsibility for any losses
**  incurred by customers or third parties arising from the use of this file.
**
**  Filename :	 main.c
**  Abstract :	This file implements main function.
**  APIlib :	Applilet2 for 78K0/Kx2 V2.41 [29 Apr. 2008]
**
**  Device :	uPD78F0512_48
**
**  Compiler :	CC78K0
**
**  Creation date:	2011/03/27
**  
*******************************************************************************
*/

/*
*******************************************************************************
**  Include files
*******************************************************************************
*/
#include "macrodriver.h"
#include "Int.h"
#include "Ad.h"
#include "Timer.h"
#include "Port.h"
#include "System.h"
/* Start user code for include definition. Do not edit comment generated here */
/* End user code for include definition. Do not edit comment generated here */
#include "user_define.h"

/*
*******************************************************************************
**  Global define
*******************************************************************************
*/
/* Start user code for global definition. Do not edit comment generated here */
/* End user code for global definition. Do not edit comment generated here */


/*
**-----------------------------------------------------------------------------
**
**	Abstract:
**		This function  implements main function.
**
**	Parameters:
**		None
**
**	Returns:
**		None
**
**-----------------------------------------------------------------------------
*/
unsigned short	ad_lev_in;
unsigned short	vol_level;
unsigned int	chousei;
unsigned char	houko;

unsigned int	khz_no;
unsigned int	out_volt_data;
unsigned int	out_volt_data_sub;

unsigned int	receive_no;

unsigned char	count;
unsigned char	offcnt;
unsigned char	offlg;
unsigned char	rec[20];
unsigned char	count18_flg;

unsigned char	receive_err;

unsigned char	test;
unsigned char	over;
unsigned char	mode;
unsigned int	adjust;
unsigned int	offset_data;
unsigned char	offset_houko;

unsigned char	band;


#define	LCD_DB4		P2.0
#define	LCD_DB5		P2.1
#define	LCD_DB6		P2.2
#define	LCD_DB7		P2.3
#define	LCD_RS		P13.0
#define	LCD_E		P14.0
#define	DAC_SCK		P7.3
#define	DAC_CS		P7.4
#define	DAC_SDI		P7.5

#define	BAND_31MB	P1.3
#define	BAND_49MB	P1.4
#define	BAND_41MB	P1.5
#define	BAND_25MB	P1.6

#define	OUT_31MB	P4.1
#define	OUT_49MB	P7.0
#define	OUT_41MB	P7.1
#define	OUT_25MB	P7.2
#define	AUTO_SEL	P4.0

#define	LCD_CMD_WAIT	300
#define	LCD_BIT_WAIT	20
#define	VOL_COUNT_SET	20

void	wait_time(unsigned int time)
{
	while(time!=0){
		time--;
	}
}
/*----------  LCD MODULE ----------*/
void	lcd_db(unsigned char data)
{
	LCD_DB4=data&0x01;
	LCD_DB5=(data&0x02)>>1;
	LCD_DB6=(data&0x04)>>2;
	LCD_DB7=(data&0x08)>>3;
}
void	lcd_wait(void)
{
	wait_time(5000);
}
void	lcd_c_set(void)
{
	LCD_RS=0;
	LCD_E=1;
	wait_time(LCD_BIT_WAIT);
	LCD_E=0;
}
void	lcd_d_set(void)
{
	LCD_RS=1;
	LCD_E=1;
	wait_time(LCD_BIT_WAIT);
	LCD_E=0;
}
void	lcd_cmd(unsigned char data)
{
	lcd_db((data&0xf0)>>4);
	lcd_c_set();
	lcd_db(data&0x0f);
	lcd_c_set();
	wait_time(LCD_CMD_WAIT);
}
void	lcd_data(unsigned char data)
{
	lcd_db((data&0xf0)>>4);
	lcd_d_set();
	lcd_db(data&0x0f);
	lcd_d_set();
	wait_time(LCD_CMD_WAIT);
}
void	lcd_init(void)
{
	lcd_wait();
	lcd_db(3);
	lcd_c_set();
	lcd_wait();
	lcd_db(3);
	lcd_c_set();
	lcd_wait();
	lcd_db(3);
	lcd_c_set();
	lcd_wait();
	lcd_db(2);
	lcd_c_set();
	lcd_wait();
	
	lcd_cmd(0x28);
	lcd_cmd(0x08);
	lcd_cmd(0x0c);
	lcd_cmd(0x06);
}
void	lcd_clear(void)
{
	lcd_cmd(0x01);
}
void	lcd_xy(unsigned char x,unsigned char y)
{
unsigned char data;

	data=0x80;
	switch (y){
		case 0:data=0x80;break;
		case 1:data=0xc0;break;
		case 2:data=0x90;break;
		case 3:data=0xd0;break;
	}
	data=data+x;
	lcd_cmd(data);
}
void	lcd_print(char *data)
{
	while (*data!=0){
		lcd_data(*data++);
	}
}
void	lcd_su(unsigned char data)
{
	switch (data){
		case 0:lcd_print("0");break;
		case 1:lcd_print("1");break;
		case 2:lcd_print("2");break;
		case 3:lcd_print("3");break;
		case 4:lcd_print("4");break;
		case 5:lcd_print("5");break;
		case 6:lcd_print("6");break;
		case 7:lcd_print("7");break;
		case 8:lcd_print("8");break;
		case 9:lcd_print("9");break;
		case 10:lcd_print("A");break;
		case 11:lcd_print("B");break;
		case 12:lcd_print("C");break;
		case 13:lcd_print("D");break;
		case 14:lcd_print("E");break;
		case 15:lcd_print("F");break;
	}
}
void	lcd_khz(unsigned int hz)
{
unsigned char n0,n1,n2,n3,n4;
unsigned int count;

	count=hz;
	n0=(unsigned char)(count%10);count=(count-n0)/10;
	n1=(unsigned char)(count%10);count=(count-n1)/10;
	n2=(unsigned char)(count%10);count=(count-n2)/10;
	n3=(unsigned char)(count%10);count=(count-n3)/10;
	n4=(unsigned char)(count%10);

	if(n4==0){lcd_print(" ");}else{lcd_su(n4);}
	lcd_su(n3);
	lcd_su(n2);
	lcd_su(n1);
	lcd_su(n0);
}
void	lcd_pr_byte(unsigned char data)
{
unsigned char data2;

	data2=data%16;data=data/16;
	lcd_su(data);
	lcd_su(data2);
}
void	lcd_ini_disp(void)
{
	lcd_xy(0,0);
	lcd_print("     kHz");
}
void	lcd_1keta10(unsigned char count)
{
unsigned char n0;

	n0=(unsigned char)(count%10);

	lcd_su(n0);
}

void	lcd_2keta10(unsigned char count)
{
unsigned char n0,n1;

	n0=(unsigned char)(count%10);count=(count-n0)/10;
	n1=(unsigned char)(count%10);

	lcd_su(n1);
	lcd_su(n0);
}
void	lcd_4keta10(unsigned int count)
{
unsigned char n0,n1,n2,n3;

	n0=(unsigned char)(count%10);count=(count-n0)/10;
	n1=(unsigned char)(count%10);count=(count-n1)/10;
	n2=(unsigned char)(count%10);count=(count-n2)/10;
	n3=(unsigned char)(count%10);

	lcd_su(n3);
	lcd_su(n2);
	lcd_su(n1);
	lcd_su(n0);
}
void	lcd_3keta10(unsigned int count)
{
unsigned char n0,n1,n2;

	n0=(unsigned char)(count%10);count=(count-n0)/10;
	n1=(unsigned char)(count%10);count=(count-n1)/10;
	n2=(unsigned char)(count%10);

	lcd_su(n2);
	lcd_su(n1);
	lcd_su(n0);
}

void	lcd_mode(void)
{
	switch(mode){
		case 0:	lcd_xy(0,0);lcd_print("=MANUAL=");
				lcd_xy(0,1);lcd_print("        ");
				break;
		case 1:	lcd_xy(0,0);lcd_print("=OFFSET=");
				lcd_xy(0,1);lcd_print("        ");
				break;
		case 2:	lcd_xy(0,0);lcd_print("     kHz");
				lcd_xy(0,1);lcd_print("        ");
				break;
	}
}
/*---------- VOLTAGE  ----------*/
void	dac_out_ch1(unsigned int data)
{
unsigned int 	d0;
unsigned char	d1;
unsigned char	i;

	DAC_SCK=0;
	DAC_CS=1;
	d0=data << 4;
	d1=0x20;
	DAC_CS=0;
	
	for(i=0;i<8;i++){
		if((d1 & 0x80)==0x80){
			DAC_SDI=1;
		}
		else{
			DAC_SDI=0;
		}
		DAC_SCK=1;
		d1=d1 << 1;
		DAC_SCK=0;
	}
	
	for(i=0;i<16;i++){
		if((d0 & 0x8000)==0x8000){
			DAC_SDI=1;
		}
		else{
			DAC_SDI=0;
		}
		DAC_SCK=1;
		d0=d0 << 1;
		DAC_SCK=0;
	}
	DAC_CS=1;
	DAC_SDI=0;
}
void	dac_out_ch2(unsigned int data)
{
unsigned int 	d0;
unsigned char	d1;
unsigned char	i;

	DAC_SCK=0;
	DAC_CS=1;
	d0=data << 4;
	d1=0x21;
	DAC_CS=0;
	
	for(i=0;i<8;i++){
		if((d1 & 0x80)==0x80){
			DAC_CS=1;
		}
		else{
			DAC_SDI=0;
		}
		DAC_SCK=1;
		d1=d1 << 1;
		DAC_SCK=0;
	}
	
	for(i=0;i<16;i++){
		if((d0 & 0x8000)==0x8000){
			DAC_SDI=1;
		}
		else{
			DAC_SDI=0;
		}
		DAC_SCK=1;
		d0=d0 << 1;
		DAC_SCK=0;
	}
	DAC_CS=1;
	DAC_SDI=0;
}


void	vol_out1(unsigned int volt)
{
	dac_out_ch1(volt);		/* DAC1 CH A */
}
void	volt_up1(void)
{
	out_volt_data++;
	if(out_volt_data>=4096){
		out_volt_data=4095;
	}
}
void	volt_down1(void)
{
	if(out_volt_data>0){
		out_volt_data--;
	}
}
void	vol_out_tun1(unsigned int volt)
{
	dac_out_ch2(volt);		/* DAC1 CH B */
}

void	vol_out_sub(unsigned int volt)
{
	vol_out1(volt);
}
void	vol_out_tun_sub(unsigned int volt)
{
	vol_out_tun1(volt);
}
unsigned int tune_volt(unsigned int no)
{
unsigned int	ret;

	if((no>=9380)&(no<9400)){ret=1920;}
	if((no>=9400)&(no<9450)){ret=1930;}
	if((no>=9450)&(no<9500)){ret=1940;}
	if((no>=9500)&(no<9550)){ret=1950;}
	if((no>=9550)&(no<9600)){ret=1960;}
	if((no>=9600)&(no<9650)){ret=1970;}
	if((no>=9650)&(no<9700)){ret=1980;}
	if((no>=9700)&(no<9750)){ret=1990;}
	if((no>=9750)&(no<9800)){ret=2000;}
	if((no>=9800)&(no<9850)){ret=2010;}
	if((no>=9850)&(no<9900)){ret=2020;}
	if((no>=9900)&(no<9950)){ret=2030;}
	if((no>=9950)&(no<=10000)){ret=2040;}
	
	if((no>=5800)&(no<5850)){ret=1260;}
	if((no>=5850)&(no<5900)){ret=1270;}
	if((no>=5900)&(no<5950)){ret=1280;}
	if((no>=5950)&(no<6000)){ret=1290;}
	if((no>=6000)&(no<6050)){ret=1300;}
	if((no>=6050)&(no<6100)){ret=1310;}
	if((no>=6100)&(no<6150)){ret=1320;}
	if((no>=6150)&(no<6200)){ret=1330;}
	if((no>=6200)&(no<6250)){ret=1340;}
	if((no>=6250)&(no<=6270)){ret=1350;}
	
	if((no>=7100)&(no<7150)){ret=1410;}
	if((no>=7150)&(no<7200)){ret=1440;}
	if((no>=7200)&(no<7250)){ret=1470;}
	if((no>=7250)&(no<7300)){ret=1500;}
	if((no>=7300)&(no<7350)){ret=1530;}
	if((no>=7350)&(no<7400)){ret=1560;}
	if((no>=7400)&(no<7450)){ret=1580;}
	if((no>=7450)&(no<7500)){ret=1590;}
	if((no>=7500)&(no<7550)){ret=1600;}
	if((no>=7550)&(no<7600)){ret=1610;}
	if((no>=7600)&(no<=7650)){ret=1620;}
	
	if((no>=11500)&(no<11600)){ret=2450;}
	if((no>=11600)&(no<11700)){ret=2480;}
	if((no>=11700)&(no<11800)){ret=2530;}
	if((no>=11800)&(no<11900)){ret=2580;}
	if((no>=11900)&(no<12000)){ret=2630;}
	if((no>=12000)&(no<12100)){ret=2680;}
	if((no>=12100)&(no<=12130)){ret=2710;}
	
	return ret;
}

unsigned int tune_volt_offset(unsigned int no)
{
unsigned int	ret;

	ret=tune_volt(no);
	
	if(offset_houko=0){
		ret=ret+offset_data;
		if(ret>=4096){ret=4095;}
	}
	else{
		if(ret<offset_data){
			ret=0;
		}
		else{
			ret=ret-offset_data;
		}
	}

	return	ret;
}

/*---------- receive signal check ----------*/
void	receive_hantei18(void){

	receive_err=0;
	if((rec[1]>=57)&&(rec[1]<=69)){}else{receive_err=1;return;}
	
	receive_no=0;
	if((rec[2]>=26)&&(rec[2]<=39)){receive_no=receive_no | 0x01;}
	if((rec[3]>=26)&&(rec[3]<=39)){receive_no=receive_no | 0x02;}
	if((rec[4]>=26)&&(rec[4]<=39)){receive_no=receive_no | 0x04;}
	if((rec[5]>=26)&&(rec[5]<=39)){receive_no=receive_no | 0x08;}
	if((rec[6]>=26)&&(rec[6]<=39)){receive_no=receive_no | 0x10;}
	if((rec[7]>=26)&&(rec[7]<=39)){receive_no=receive_no | 0x20;}
	if((rec[8]>=26)&&(rec[8]<=39)){receive_no=receive_no | 0x40;}
	if((rec[9]>=26)&&(rec[9]<=39)){receive_no=receive_no | 0x80;}
	if((rec[10]>=26)&&(rec[10]<=39)){receive_no=receive_no | 0x100;}
	if((rec[11]>=26)&&(rec[11]<=39)){receive_no=receive_no | 0x200;}
	if((rec[12]>=26)&&(rec[12]<=39)){receive_no=receive_no | 0x400;}
	if((rec[13]>=26)&&(rec[13]<=39)){receive_no=receive_no | 0x800;}
	if((rec[14]>=26)&&(rec[14]<=39)){receive_no=receive_no | 0x1000;}
	if((rec[15]>=26)&&(rec[15]<=39)){receive_no=receive_no | 0x2000;}
	if((rec[16]>=26)&&(rec[16]<=39)){receive_no=receive_no | 0x4000;}
	if((rec[17]>=26)&&(rec[17]<=39)){receive_no=receive_no | 0x8000;}

}

/*----------  A/D ----------*/
void	ad_input7(void)
{
    WTMK = 1;			/* INTWT Interrupt servicing disabled */
	AD_SelectADChannel(AD_INPUT_CHANNEL_7);
	AD_Read(&ad_lev_in);
    WTMK = 0;			/* INTWT Interrupt servicing enabled */
	
}
void	ad_input6(void)
{
    WTMK = 1;			/* INTWT Interrupt servicing disabled */
	AD_SelectADChannel(AD_INPUT_CHANNEL_6);
	AD_Read(&ad_lev_in);
    WTMK = 0;			/* INTWT Interrupt servicing enabled */
	
}

void	vol_henkan(unsigned short da)
{
	if(da<500){
		houko=1;
		chousei=(500-da)/5;
	}
	else{
		houko=0;
		chousei=(da-500)/5;
	}
}
void	offset_set(void)
{
	out_volt_data=tune_volt(khz_no);
	if(out_volt_data>adjust){
		offset_data=out_volt_data-adjust;
		offset_houko=1;
	}
	else{
		offset_data=adjust-out_volt_data;
		offset_houko=0;
	}
}
/*---------- MAIN -----------*/
void  main( void )
{

unsigned char	sw1_key;
unsigned char	sw1_rep;
unsigned char	sw1_cnt;
unsigned char	sw2_key;
unsigned char	sw2_rep;
unsigned char	sw2_cnt;

unsigned char	sw4_key;
unsigned char	sw4_rep;
unsigned char	sw4_cnt;
unsigned char	sw5_key;
unsigned char	sw5_rep;
unsigned char	sw5_cnt;
unsigned char	sw6_key;
unsigned char	sw6_rep;
unsigned char	sw6_cnt;
unsigned char	sw7_key;
unsigned char	sw7_rep;
unsigned char	sw7_cnt;



unsigned int	vol_count;
unsigned int	offset_count;



	out_volt_data=0;

	P13.0=0;P14.0=0;

	sw1_key=0;sw1_rep=0;sw1_cnt=0;
	sw2_key=0;sw2_rep=0;sw2_cnt=0;
	sw4_key=0;sw4_rep=0;sw4_cnt=0;
	sw4_key=0;sw4_rep=0;sw4_cnt=0;
	sw5_key=0;sw5_rep=0;sw5_cnt=0;
	sw6_key=0;sw6_rep=0;sw6_cnt=0;
	sw7_key=0;sw7_rep=0;sw7_cnt=0;

	mode=0;
	offset_data=0;
	offset_houko=0;
	
	band=0;
	
	khz_no=0;
	
	count=0;offcnt=0;offlg=0;
	count18_flg=0;
	
	test=0;
	over=0;
	vol_count=VOL_COUNT_SET;
	offset_count=VOL_COUNT_SET;

	AD_Start();
	
	lcd_init();
	lcd_clear();

	lcd_mode();
	
	TM50_Start();

	PMK0 = 0;		/* INTP0 enable */
	

	/* Start user code. Do not edit comment generated here */
	while (1) {
	/* key scan 1 */
		if (P1.0==0){
				sw1_key=0;
		}
		else{
			sw1_key=1;
			sw1_rep=0;
			sw1_cnt=0;
		}
		/*------------------*/
		if (P1.1==0){
				sw2_key=0;
		}
		else{
			sw2_key=1;
			sw2_rep=0;
			sw2_cnt=0;
		}
		/*------------------*/
		if (BAND_31MB==0){
				sw4_key=0;
		}
		else{
			sw4_key=1;
			sw4_rep=0;
			sw4_cnt=0;
		}
		/*------------------*/
		if (BAND_49MB==0){
				sw5_key=0;
		}
		else{
			sw5_key=1;
			sw5_rep=0;
			sw5_cnt=0;
		}
		/*------------------*/
		if (BAND_41MB==0){
				sw6_key=0;
		}
		else{
			sw6_key=1;
			sw6_rep=0;
			sw6_cnt=0;
		}
		/*------------------*/
		if (BAND_25MB==0){
				sw7_key=0;
		}
		else{
			sw7_key=1;
			sw7_rep=0;
			sw7_cnt=0;
		}
		/*------------------*/



		wait_time(2000);

		/*------------------*/
		
	/* key scan 2 */
		if ((P1.0==0)&(sw1_key==0)){
			sw1_key=0;
		}
		else{
			sw1_key=1;
			sw1_rep=0;
			sw1_cnt=0;
		}
		/*------------------*/
		if ((P1.1==0)&(sw2_key==0)){
			sw2_key=0;
		}
		else{
			sw2_key=1;
			sw2_rep=0;
			sw2_cnt=0;
		}
		/*------------------*/
		if ((BAND_31MB==0)&(sw4_key==0)){
			sw4_key=0;
		}
		else{
			sw4_key=1;
			sw4_rep=0;
			sw4_cnt=0;
		}
		/*------------------*/
		if ((BAND_49MB==0)&(sw5_key==0)){
			sw5_key=0;
		}
		else{
			sw5_key=1;
			sw5_rep=0;
			sw5_cnt=0;
		}
		/*------------------*/
		if ((BAND_41MB==0)&(sw6_key==0)){
			sw6_key=0;
		}
		else{
			sw6_key=1;
			sw6_rep=0;
			sw6_cnt=0;
		}
		/*------------------*/
		if ((BAND_25MB==0)&(sw7_key==0)){
			sw7_key=0;
		}
		else{
			sw7_key=1;
			sw7_rep=0;
			sw7_cnt=0;
		}
		/*------------------*/


	/* key action */
	
		if((sw1_key==0)&(sw1_rep==0)){
			sw1_rep=1;
			/*
			out_volt_data=out_volt_data+50;
			if(out_volt_data>=4096){
				out_volt_data=0;
			}
			lcd_xy(4,1);lcd_4keta10(out_volt_data);
			vol_out_sub(out_volt_data);
			*/
			
			switch(mode){
				case 0:
						break;
				case 1:	
						ad_input6();
						adjust=ad_lev_in*4;
						offset_set();
						mode=2;
						lcd_ini_disp();
						lcd_xy(0,0);
						lcd_khz(khz_no);
						out_volt_data=tune_volt_offset(khz_no);
						lcd_xy(4,1);lcd_4keta10(out_volt_data);
						vol_out_sub(out_volt_data);
						AUTO_SEL=1;
						break;
				case 2:	mode=1;
						lcd_mode();
						AUTO_SEL=1;
						break;
			}
		}

		if((sw2_key==0)&(sw2_rep==0)){
			sw2_rep=1;
			/*
			if(out_volt_data<50){
				out_volt_data=4000;
			}
			else{
				out_volt_data=out_volt_data-50;
			}
			lcd_xy(4,1);lcd_4keta10(out_volt_data);
			vol_out_sub(out_volt_data);
			*/
			
			switch(mode){
				case 0:	if(sw4_key==0){
							mode=2;
							lcd_ini_disp();
							lcd_xy(0,0);
							lcd_khz(khz_no);
							AUTO_SEL=1;
						}
						if(sw5_key==0){
							mode=2;
							lcd_ini_disp();
							lcd_xy(0,0);
							lcd_khz(khz_no);
							AUTO_SEL=1;
						}
						if(sw6_key==0){
							mode=2;
							lcd_ini_disp();
							lcd_xy(0,0);
							lcd_khz(khz_no);
							AUTO_SEL=1;
						}
						if(sw7_key==0){
							mode=2;
							lcd_ini_disp();
							lcd_xy(0,0);
							lcd_khz(khz_no);
							AUTO_SEL=1;
						}
						break;
				case 1:	mode=0;
						lcd_mode();
						AUTO_SEL=0;
						break;
				case 2:	mode=0;
						lcd_mode();
						AUTO_SEL=0;
						break;
			}
		}
		
		if((sw4_key==0)&(sw4_rep==0)){
			sw4_rep=1;
			mode=2;
			lcd_mode();
			AUTO_SEL=1;
			OUT_31MB=1;OUT_49MB=0;OUT_41MB=0;OUT_25MB=0;
		}
		if((sw5_key==0)&(sw5_rep==0)){
			sw5_rep=1;
			mode=2;
			lcd_mode();
			AUTO_SEL=1;
			OUT_31MB=0;OUT_49MB=1;OUT_41MB=0;OUT_25MB=0;
		}
		if((sw6_key==0)&(sw6_rep==0)){
			sw6_rep=1;
			mode=2;
			lcd_mode();
			AUTO_SEL=1;
			OUT_31MB=0;OUT_49MB=0;OUT_41MB=1;OUT_25MB=0;
		}
		if((sw7_key==0)&(sw7_rep==0)){
			sw7_rep=1;
			mode=2;
			lcd_mode();
			AUTO_SEL=1;
			OUT_31MB=0;OUT_49MB=0;OUT_41MB=0;OUT_25MB=1;
		}
		if((sw4_key==1)&(sw5_key==1)&(sw6_key==1)&(sw7_key==1)){
			AUTO_SEL=0;
			mode=0;
			offset_data=0;
			offset_houko=0;
			lcd_mode();
			OUT_31MB=0;OUT_49MB=0;OUT_41MB=0;OUT_25MB=0;
		}

		
		/*------------------*/

	/* receive data hantei */

		if(count18_flg==1){
			count18_flg=0;
			receive_hantei18();
			if((receive_no>=3000) && (receive_no<=15000) && (receive_err==0)){
				khz_no=receive_no;
				/*khz_set();*/
				if(mode==2){
					lcd_xy(0,0);lcd_khz(khz_no);
					out_volt_data=tune_volt_offset(khz_no);
					lcd_xy(4,1);lcd_4keta10(out_volt_data);
					vol_out_sub(out_volt_data);
				}
			}
		}

	/*--------------------*/
		
	/* A/D input */
		if(mode==2){
		/*----------*/
		if(vol_count>0){vol_count--;}
		if(vol_count==0){
			ad_input7();
			vol_level=ad_lev_in;
			vol_henkan(vol_level);
			if(houko==0){
				out_volt_data_sub=out_volt_data+chousei;
				if(out_volt_data_sub>=4000){out_volt_data_sub=4000;}
			}
			else{
				if(out_volt_data<chousei){
					out_volt_data_sub=0;
				}
				else{
					out_volt_data_sub=out_volt_data-chousei;
				}
			}
		lcd_xy(4,1);lcd_4keta10(out_volt_data_sub);
		vol_out_sub(out_volt_data_sub);
		vol_count=VOL_COUNT_SET;
		}
		/*---------*/
		}
		
		if(mode==1){
		/*----------*/
		if(offset_count>0){offset_count--;}
		if(offset_count==0){
			ad_input6();
			adjust=ad_lev_in*4;
			lcd_xy(4,1);
			lcd_4keta10(adjust);
			vol_out_sub(adjust);
			offset_count=VOL_COUNT_SET;
		}
		/*----------*/
		}
		
	/*---------------------*/
	
		if(over!=0){
			over++;
			if(over>100){count=0;over=0;}
		}

	}
	/* End user code. Do not edit comment generated here */
}

/* Start adding user code. Do not edit comment generated here */
/* End user code adding. Do not edit comment generated here */


